/* Form definition file generated with fdesign. */
#include "xfwish.h"
/*
taken from chanwin.c and chanwin_cb.c in sula-0.1.82
*/

typedef struct {
        FL_FORM *getstring;
        void *vdata;
        long ldata;
        FL_OBJECT *base;
        FL_OBJECT *label;
        FL_OBJECT *input;
	FL_OBJECT *button_grp;
        FL_OBJECT *ready;
        FL_OBJECT *timer;
        FL_OBJECT *cancel;
        FL_OBJECT *fname;
} FD_getstring; 
static int     input_type;
char   *label;
/*char   *deflt_value = NULL;*/
int     attrib2 = '.', attrib1 = FL_INPUT_DDMM;
int browse;
char shortcut[5];
static int reset_on_return=0;
static void   getstring_cb(FL_OBJECT * ob, long data);
static FD_getstring *create_form_getstring(void)
{
  FL_OBJECT *obj;
  FD_getstring *fdui = (FD_getstring *) fl_calloc(1, sizeof(*fdui));

  fdui->getstring = fl_bgn_form(FL_NO_BOX, 400, 160);
  fdui->base = obj = fl_add_box(FL_UP_BOX,0,0,400,160,"");
    fl_set_object_resize(obj, FL_RESIZE_X);
    fl_set_object_color(obj,bgcolor,0);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,380,140,"");
    fl_set_object_gravity(obj, FL_West, FL_NoGravity);
    fl_set_object_resize(obj, FL_RESIZE_X);
  fdui->label = obj = fl_add_text(FL_NORMAL_TEXT,15,15,370,40,"Text");
    fl_set_object_boxtype(obj, labelboxtype);
    fl_set_object_lsize(obj,labelfontsize);
    fl_set_object_lstyle(obj,labelfontstyle);
    fl_set_object_lcolor(obj,fgcolor);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
    fl_set_object_gravity(obj, FL_West, FL_NoGravity);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
  obj = fl_add_box(FL_NO_BOX,10,50,380,15,"@DnLine");
    fl_set_object_gravity(obj, FL_West, FL_NoGravity);
    fl_set_object_resize(obj, FL_RESIZE_X);
  fdui->input = obj = fl_add_input(input_type,20,70,365,30,"");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_West, FL_NoGravity);
    fl_set_object_resize(obj, FL_RESIZE_X);
    fl_set_object_callback(obj,getstring_cb,(long)0);
    if(input_type==FL_SECRET_INPUT)
    	fl_set_object_color(obj,bgcolor, bgcolor);
  fdui->timer = obj = fl_add_timer(FL_VALUE_TIMER,305,125,80,20,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_callback(obj,getstring_cb,(long)2);

  fdui->button_grp = fl_bgn_group();
  fdui->ready = obj = fl_add_button(FL_RETURN_BUTTON,45,110,65,30,yeslabel);
    fl_set_object_gravity(obj, FL_West, FL_NoGravity);
    fl_set_object_color(obj,upcolor, downcolor);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_boxtype(obj,boxtype);
 fdui->fname = obj = fl_add_button(FL_NORMAL_BUTTON,230,110,65,30,"Browse");
    /*fl_set_button_shortcut(obj,"#b#B",1);*/
    fl_set_object_color(obj,upcolor, downcolor);
    fl_set_object_gravity(obj, FL_West, FL_NoGravity);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_callback(obj,getstring_cb,(long)1);
    fl_set_object_boxtype(obj,boxtype);
 if(browse)
  fdui->cancel = obj = fl_add_button(FL_NORMAL_BUTTON,137,110,65,30,nolabel);
  else
  fdui->cancel = obj = fl_add_button(FL_NORMAL_BUTTON,230,110,65,30,nolabel);
    /*fl_set_button_shortcut(obj,"#C#c",1);*/
    if(*yeslabel!=*nolabel) sprintf(shortcut,"#%c", *nolabel);
    else sprintf(shortcut,"#%c", isupper(*nolabel)?tolower(*nolabel):toupper(*nolabel));
    fl_set_button_shortcut(obj,shortcut,1);
    fl_set_object_gravity(obj, FL_West, FL_NoGravity);
    fl_set_object_color(obj,upcolor, downcolor);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_boxtype(obj,boxtype);
  
  fl_end_group();
  fl_set_object_lsize(fdui->button_grp,fontsize);
  fl_set_object_lstyle(fdui->button_grp,fontstyle);
  fl_set_object_lcolor(fdui->button_grp,labelcolor);
  fl_end_form();

  fdui->getstring->fdui = fdui;

  return fdui;
}
/*---------------------------------------*/
typedef struct {
	FL_FORM *minput;
	void *vdata;
	long ldata;
	FL_OBJECT *base;
	FL_OBJECT *mline;
	FL_OBJECT *button_grp;
	FL_OBJECT *send;
	FL_OBJECT *close;
	FL_OBJECT *clear;
} FD_minput;
static void    minput_cb_cb(FL_OBJECT * ob, long data);
static FD_minput *create_form_minput(void)
{
  FL_OBJECT *obj;
  FD_minput *fdui = (FD_minput *) fl_calloc(1, sizeof(*fdui));

  fdui->minput = fl_bgn_form(FL_NO_BOX, 385, 195);
  fdui->base = obj = fl_add_box(FL_UP_BOX,0,0,385,195,"");
  fl_set_object_lcolor(obj,bgcolor);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,8,6,370,182,"");
  fl_set_object_gravity(obj, FL_NorthWest, FL_SouthEast);
  fdui->mline = obj = fl_add_input(FL_MULTILINE_INPUT,15,15,355,130,"");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_SouthEast);

  fdui->button_grp = fl_bgn_group();
  fdui->send = obj = fl_add_button(FL_NORMAL_BUTTON,37,152,75,30,yeslabel);
    fl_set_object_gravity(obj, FL_SouthWest, FL_SouthWest);
    fl_set_object_callback(obj,minput_cb_cb,(long)0);
    fl_set_object_boxtype(obj,boxtype);
    fl_set_object_color(obj,upcolor, downcolor);

  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,190,152,75,30,dismisslabel);
    fl_set_object_gravity(obj, FL_SouthWest, FL_SouthWest);
    fl_set_object_callback(obj,minput_cb_cb,(long)2);
    fl_set_object_boxtype(obj,boxtype);
    fl_set_object_color(obj,upcolor, downcolor);

  fdui->clear = obj = fl_add_button(FL_NORMAL_BUTTON,113,152,75,30,"Clear");
    fl_set_object_gravity(obj, FL_SouthWest, FL_SouthWest);
    fl_set_object_callback(obj,minput_cb_cb,(long)1);
    fl_set_object_boxtype(obj,boxtype);
    fl_set_object_color(obj,upcolor, downcolor);

  fl_end_group();
  fl_set_object_lsize(fdui->button_grp,fontsize);
  fl_set_object_lstyle(fdui->button_grp,fontstyle);
  fl_set_object_lcolor(fdui->button_grp,labelcolor);
  fl_end_form();

  fdui->minput->fdui = fdui;

  return fdui;
}
static void   getminput(const char *label,const  char *def)
{

	FD_minput *form= create_form_minput();
	fl_set_input_color(form->mline, fgcolor, fgcolor);
	form->mline->u_ldata =(long)  XC_xterm;
	fl_set_object_prehandler(form->mline, set_cursor);
	form->send->u_vdata = (void *)form->mline;
	form->clear->u_vdata = (void *) form->mline;
	if(width<385) width=385;
	if(height<185) height=185;
	if(def) fl_set_input(form->mline, def);
	fl_set_form_minsize(form->minput, 385, 185);
	fl_show_form(form->minput, placement, border,title);
	fl_do_forms();
}
static void    minput_cb_cb(FL_OBJECT * ob, long data)
{
	switch (data) {
	    case 0:		/*send */
		    printf("%s\n", (char *)fl_get_input((FL_OBJECT *)ob->u_vdata));
		    exit(0);
	    case 1:		/* clear */
		    fl_set_input((FL_OBJECT *) ob->u_vdata, "");
		    break;

	    case 2:{		/*dismiss */
	    exit(0);
		    }
	    default:
		    break;
	}

}

 static char *getstr2(const char *label,const char *deflt_val, int type,
  const char *ext, const char *dir )
{
	FD_getstring *form;
	FL_OBJECT *answer;
	char   *val;
	double  tmout = (double) timeout;
	double xsc=1.0, ysc=1.0;

	if(type==  FL_MULTILINE_INPUT) getminput(label, deflt_val);/* doesnt return*/
	form = create_form_getstring();
	if(width) xsc=width/form->getstring->w;
	if(height) ysc=height/form->getstring->h;
	if(width || height) fl_scale_form(form->getstring, xsc, ysc);
	fl_set_object_label(form->label, label);
	fl_adjust_form_size(form->getstring);
	fl_set_input_return(form->input, FL_RETURN_ALWAYS);
	if(input_type==FL_SECRET_INPUT)
		fl_set_input_color(form->input, bgcolor, bgcolor);
	else
		fl_set_input_color(form->input, fgcolor, fgcolor);
	form->input->u_vdata = (void *) &tmout;
	fl_set_object_prehandler(form->input, set_cursor);
	form->input->u_ldata = (long) XC_xterm;
	if (type == FL_DATE_INPUT);
		fl_set_input_format(form->input, attrib1, attrib2);
	if (deflt_val){
		if (type != FL_INT_INPUT && type != FL_FLOAT_INPUT)
			fl_set_input(form->input, deflt_val);
		else {
			char   *s = (char *) malloc(sizeof(char) * (strlen(deflt_val) + 16));

			if (!s) {
				fprintf(stderr, "Memory failure: %s\n", strerror(errno));
				exit(-1);
			}
			if (type == FL_FLOAT_INPUT)
				sprintf(s, "%f", atof(deflt_val));
			else
				sprintf(s, "%d", atoi(deflt_val));
			fl_set_input(form->input, s);
		}
	}
	
	/*fl_set_form_minsize(form->getstring, 400, 160);
	fl_set_form_maxsize(form->getstring, 600, 160); */
	if(timeout) fl_set_timer(form->timer, timeout);
	if (!browse)
		fl_hide_object(form->fname);
	else {
		form->fname->u_vdata = (void *) deflt_val;
		form->ready->u_vdata = (void *) ext;
		form->cancel->u_vdata = (void *) dir;
	}
	fl_show_form(form->getstring, placement,border, title);
	fl_set_focus_object(form->getstring, form->input);
	while ((answer = fl_do_forms()) != form->ready && answer != form->cancel);
	val = (answer == form->ready) ? strdup((char *)fl_get_input(form->input)) : NULL;
	fl_hide_form(form->getstring);
	fl_free_form(form->getstring);
	return val;
}
static void zap_fselector(int id, void *junk)
{
	FD_FSELECTOR *fselector = fl_get_fselector_fdstruct();

	fl_trigger_object(fselector->cancel);

}

static void   getstring_cb(FL_OBJECT * ob, long data)
{
	FD_getstring *form = (FD_getstring *) ob->form->fdui;

	switch (data) {
	    case 0:		/* input */
		    if(reset_on_return)
		    fl_set_timer(form->timer, *((double *) ob->u_vdata));
		    break;
	    case 1:{		/* browse */
			    char   *fname, *ext=(char *) form->ready->u_vdata,
			     *dir=(char *) form->cancel->u_vdata;
			    char   *deflt = (char *) ob->u_vdata;
			    int     timeout = fl_add_timeout((*((double *) form->input->u_vdata)) * 1000, zap_fselector, NULL);

			    fl_suspend_timer(form->timer);
			    fl_set_cursor(form->getstring->window, XC_watch);
			    if(!deflt) deflt="*";
			    if(!ext) ext="*";
			    if(!dir) dir=".";
			    fl_set_fselector_title(title);
			    fname = (char *) fl_show_fselector("Selection:", dir, ext, deflt);
			    if (fname) {
				    fl_set_input(form->input, fname);
				    fl_remove_timeout(timeout);
			    }
			    fl_reset_cursor(form->getstring->window);
			    fl_resume_timer(form->timer);
			    break;
		    }
	    case 2:{		/* timer */
			    fl_trigger_object(form->ready);
		    }
		    break;

	    default:
		    break;
	}			/* switch */
}
void do_getstring(int argc, char **argv){
	char *result=NULL;

	char *deflt_value = NULL;
	attrib2 = '.', attrib1 = FL_INPUT_DDMM;
	input_type = FL_NORMAL_INPUT;
	label = NULL;
	 reset_on_return=0;
	while (1) {
		int     i, option_index = 0;
		static struct option long_options[] =
		{
			{"integer", 0, 0, 'i'},
			{"float", 0, 0, 'f'},
			{"string", 0, 0, 's'},
			{"date", 0, 0, 'd'},
			{"dateformat", 1, 0, 'o'},
			{"dateseperator", 1, 0, 'e'},
			{"password", 0, 0, 'p'},
			{"hidden", 0, 0, 'h'},
		#if 1
			{"multiline", 0, 0, 'm'},
		#endif
			{"default", 1, 0, 'D'},
			{"label", 1, 0, 'l'},
			{"reset-on-return",0,0,'r'},
			{0, 0, 0, 0}
		};

		i = getopt_long(argc, argv, "",
				long_options, &option_index);
		if (i == -1)
			break;

		switch (i) {
		    case 'i':
			    input_type = FL_INT_INPUT;
			    break;
		    case 'f':
			    input_type = FL_FLOAT_INPUT;
			    break;
		    case 'p':
			    input_type = FL_SECRET_INPUT;
			    break;
		    case 'h':
			    input_type = FL_HIDDEN_INPUT;
			    break;
		    case 's':
			    input_type = FL_NORMAL_INPUT;
			    break;
		    case 'd':
			    input_type = FL_DATE_INPUT;
			    break;
		    case 'o':
			    if (!strcasecmp(optarg, "MMDD"))
				    attrib1 = FL_INPUT_MMDD;
			    else
				    attrib1 = FL_INPUT_MMDD;
			    break;
		    case 'e':
			    attrib2 = *optarg;
			    break;
		    case 'm':
			    input_type = FL_MULTILINE_INPUT;
			    break;
		    case 'D':
			    deflt_value = optarg;

			    break;
		    case 'l':
			    label = optarg;
			    break;
		    case 'r':
		   	reset_on_return=1;
			break;
		    case '?':
			    break;
		    default:
			    break;
		}		/* switch */
	}			/* while(1) */
	label=buildstr(label);
	if (!label)
		switch (input_type) {
		    case FL_NORMAL_INPUT:
		    case FL_SECRET_INPUT:
		    case FL_MULTILINE_INPUT:
		    default:
			    label = "Some text:";
			    break;
		    case FL_INT_INPUT:
			    label = "Whole number";
			    break;
		    case FL_FLOAT_INPUT:
			    label = "Floating point number";
			    break;
		    case FL_DATE_INPUT:
			    {
				    char    buf[32];

				    if (attrib1 == FL_INPUT_MMDD)
					    sprintf(buf, "Type a date (mm%cdd%cyyyy)", attrib2, attrib2);
				    else
					    sprintf(buf, "Type a date (dd%cmm%cyyyy)", attrib2, attrib2);
				    label = strdup(buf);
				    break;
			    }
		}		/* switch */
	result=getstr2(label, deflt_value, input_type, NULL, NULL);
	if(result) printf("%s\n", result);
	exit(0);
}
void do_getfname(int argc, char **argv)
{
	char   *pat = NULL;
	char   *directory = NULL;
	char   *result;
	char   *default_file = NULL;
	int     i = 0;
	browse=1;
	while (1) {
		int     i, option_index = 0;
		static struct option long_options[] =
		{
			{"pattern", 1, 0, 'p'},
			{"directory", 1, 0, 'd'},
			{"default", 1, 0, 'f'},
			{"label", 1, 0, 'l'},
			{"reset-on-return",0,0,'r'},
			{0, 0, 0, 0}
		};
		i = getopt_long(argc, argv, "",
				long_options, &option_index);
		if (i == -1)
			break;

		switch (i) {
		    case 'p':{
				    pat = optarg;
				    break;
			    }
		    case 'd':{
				    directory = optarg;
				    break;
			    }
		    case 'f':{
				    default_file = optarg;
				    break;
			    }
		    case 'l':
			    label = optarg;
			    break;
		    case 'r':
		   	reset_on_return=1;
			break;
		    case '?':
			    break;
		    default:
			    break;
		}		/* switch */
	}			/* while(1) */
       label=buildstr(label);	
       result=getstr2(label,default_file, FL_NORMAL_INPUT,pat, directory );
	if (result)
		printf("%s\n", result);
	exit(0);
}
char   *pat;
char   *directory;
static void brow_cb(FL_OBJECT *, long);
typedef struct {
	FL_FORM *copying;
	void *vdata;
	long ldata;
	FL_OBJECT *button_grp;
	FL_OBJECT *browser;
	FL_OBJECT *dismiss;
	FL_OBJECT *newfile;
} FD_copying;

static FD_copying * create_form_copying(void)
{
  FL_OBJECT *obj;
  FD_copying *fdui = (FD_copying *) fl_calloc(1, sizeof(*fdui));

  fdui->copying = fl_bgn_form(FL_NO_BOX, 530, 380);
  obj = fl_add_box(FL_DOWN_BOX,0,0,530,380,"");
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,510,360,"");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NoGravity);
  fdui->browser = obj = fl_add_browser(FL_HOLD_BROWSER,15,15,500,315,"");
  fdui->button_grp = fl_bgn_group();
  fdui->dismiss = obj = fl_add_button(FL_NORMAL_BUTTON,160,335,70,30,dismisslabel);
    /*fl_set_object_gravity(obj, FL_SouthWest, FL_NoGravity);*/
    fl_set_object_color(obj,upcolor, downcolor);
    fl_set_object_boxtype(obj,boxtype);
    fl_set_object_callback(obj,brow_cb,(long)0);
  fdui->newfile = obj = fl_add_button(FL_NORMAL_BUTTON,300,335,70,30,"New file!");
    /*fl_set_object_gravity(obj, FL_SouthWest, FL_NoGravity);*/
    fl_set_object_color(obj,upcolor, downcolor);
    fl_set_object_boxtype(obj,boxtype);
    fl_set_object_callback(obj,brow_cb,(long)1);
  fl_end_group();
  fl_set_object_lsize(fdui->button_grp,fontsize);
  fl_set_object_lstyle(fdui->button_grp,fontstyle);
  fl_set_object_lcolor(fdui->button_grp,labelcolor);
  fl_end_form();

  fdui->copying->fdui = fdui;

  return fdui;
}
#include <unistd.h>
static void    brow_cb(FL_OBJECT * ob, long data)
{
	switch (data) {
	    case 1:{
		FD_copying *form;
		char   /**pat=(char *) form->dismiss->u_vdata,
			 *dir=(char *) form->browser->u_vdata, */
			   *pat = (char *) ob->u_vdata;
		char *file;
		/*if(!deflt) deflt="*";*/
			    if(!pat) pat="*";
			    /*if(!dir) dir=".";*/
		file=getstr2(label, "", FL_NORMAL_INPUT,pat, "" );
		if(!file || !*file) return;
		if (access(file, R_OK) < 0){
			fl_show_alert(title, file, strerror(errno), 1);
			break;
		}
		fl_load_browser(((FD_copying *) ob->form->fdui)->browser, file);
		return;
	 	}
	    case 0:
		exit(0);
	    default:
		    break;
	}
}

void do_browsefile(int argc, char *argv[]){

	FD_copying *form;
	char   *pat = NULL;
	char   *dir = NULL;
	char   *def = NULL;
	double xsc=1.0, ysc=1.0;
	browse=1;
	reset_on_return=0;
	while (1) {
		int     i, option_index = 0;
		static struct option long_options[] =
		{
			{"pattern", 1, 0, 'p'},
			{"directory", 1, 0, 'd'},
			{"default", 1, 0, 'f'},
			{"label", 1, 0, 'l'},
			{"reset-on-return",0,0,'r'},
			{0, 0, 0, 0}
		};
		i = getopt_long(argc, argv, "",
				long_options, &option_index);
		if (i == -1)
			break;

		switch (i) {
		    case 'p':{
				    pat = optarg;
				    break;
			    }
		    case 'd':{
				    dir = optarg;
				    break;
			    }
		    case 'f':{
				    def = optarg;
				    break;
			    }
		    case 'l':
			    label = optarg;
			    break;
		    case 'r':
		   	reset_on_return=1;
			break;
		    case '?':
			    break;
		    default:
			    break;
		}		/* switch */
	}			/* while(1) */
	if(def)
		if (access(def, R_OK) < 0){
			fl_show_alert(title, def, strerror(errno), 1);
			exit(1);
		}
	if(!def)
		def=getstr2(label, "", FL_NORMAL_INPUT,pat, dir );
	if(!def) exit(1);
	if (access(def, R_OK) < 0){
			fl_show_alert(title, def, strerror(errno), 1);
			exit(1);
		}
	form = create_form_copying();
	fl_set_browser_fontsize(form->browser, fontsize);
	fl_set_browser_fontstyle(form->browser, fontstyle);
	if(width) xsc=width/form->copying->w;
	if(height) ysc=height/form->copying->h;
	if(width || height) fl_scale_form(form->copying, xsc, ysc);
	fl_adjust_form_size(form->copying);

	form->newfile->u_vdata = (void *) (pat? pat:"*");
	/*
		form->dismiss->u_vdata = (void *) pat;
		form->browser->u_vdata = (void *) dir; */
	fl_load_browser(form->browser, def);
	fl_show_form(form->copying, placement, border,title);
	while(fl_do_forms()!=form->dismiss);
}
